'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = combineReducers;

var _lodash = require('lodash.reduce');

var _lodash2 = _interopRequireDefault(_lodash);

var _lodash3 = require('lodash.foreach');

var _lodash4 = _interopRequireDefault(_lodash3);

var _lodash5 = require('lodash.mapvalues');

var _lodash6 = _interopRequireDefault(_lodash5);

var _lodash7 = require('lodash.size');

var _lodash8 = _interopRequireDefault(_lodash7);

var _immutable = require('immutable');

var _mindfrontReduxUtils = require('mindfront-redux-utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function combineReducers(reducers) {
  var createInitialState = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _immutable.Map;

  var actionHandlers = {};
  var otherReducers = {};
  var initialStateObj = {};
  (0, _lodash4.default)(reducers, function (reducer, key) {
    initialStateObj[key] = reducer(undefined, {});
    if (reducer.actionHandlers) {
      // invert from prop name -> action type -> reducer
      //          to action type -> prop name -> reducer
      (0, _lodash4.default)(reducer.actionHandlers, function (actionHandler, type) {
        (actionHandlers[type] || (actionHandlers[type] = {}))[key] = actionHandler;
      });
    } else otherReducers[key] = reducer;
  });
  var initialState = createInitialState(initialStateObj);

  var combineBase = function combineBase(reducers) {
    var result = function result() {
      var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
      var action = arguments[1];
      return state.withMutations(function (mutableState) {
        return (0, _lodash2.default)(reducers, function (nextState, reducer, key) {
          return nextState.update(key, function (value) {
            return reducer(value, action);
          });
        }, mutableState);
      });
    };
    result.domainHandlers = reducers;
    return result;
  };

  var actionHandlerReducer = (0, _lodash8.default)(actionHandlers) ? (0, _mindfrontReduxUtils.createReducer)(initialState, (0, _lodash6.default)(actionHandlers, combineBase)) : undefined;

  var otherReducer = (0, _lodash8.default)(otherReducers) ? combineBase(otherReducers) : undefined;

  if (actionHandlerReducer && otherReducer) return (0, _mindfrontReduxUtils.composeReducers)(actionHandlerReducer, otherReducer);else if (actionHandlerReducer) return actionHandlerReducer;else if (otherReducer) return otherReducer;else return function () {
    var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
    return state;
  };
}